<template>
  <div class="syslog">
    <!-- <searchBox :btn-option-list="btnOptionList" @operateForm="operateForm"></searchBox> -->

    <div class="content-table">
      <ComTable
        :columns="columns"
        :table-data="tableData"
        @handlePagesizeChange="handlePagesizeChange"
        ref="comTable"
        :page-option="pageOption"
      >
        <template #status="record">
          <span>
            <a-tag :color="record.status==0 ? 'red' : 'green'">{{
              record.status==0 ? '异常' : '正常'
            }}</a-tag>
            </span>
        </template>

        <template #action="record">
          <OperateCom :record="record" :operate-list="operateList" @operateForm="operateForm" />
        </template>
      </ComTable>
    </div>
    <a-modal v-model:open="formModal" width="750px" style="top: 80px" :footer="null">
      <!-- action:edit add -->
      <EditCom
        :record="formState"
        @operateForm="operateForm"
        type="syslog"
        :action="formStatus"
      ></EditCom>
    </a-modal>
  </div>
</template>

<script>
import { columnList, syslogOptions } from '../../../public/config/columnList'
import { getReq, postReq } from '@/request/api.js'

import EditCom from '@/components/EditCom.vue'
import { ExclamationCircleOutlined } from '@ant-design/icons-vue'
import { createVNode } from 'vue'

export default {
  name: '',
  components: {
    EditCom
  },
  props: {},
  data() {
    return {
      formModal: false,
      formState: {},
      formStatus: 'add', //表单状态辑状态 add:新增 edit:编辑
      pageOption: {
        pageSize: 10,
        page: 1
      },
      btnOptionList: [],
      paramsDate: {},
      tableData: []
    }
  },
  computed: {},
  created() {
    let info = []
    let col = columnList.find((i) => i.page == 'syslog').columns
    if (col.length) {
      col.forEach((item) => {
        info.push(this.$setWidth(item))
      })
    }
    this.columns = info
  },

  mounted() {
    this.operateList = this.$getBtns(['查看'])
    // this.btnOptionList = this.$getBtns(['新增'])
    this.getList()
  },

  methods: {
    async getList() {
      this.$refs.comTable.loading = true

      const { page, pageSize } = this.pageOption

      const params = {
        ...this.paramsDate,
        page_size: pageSize,
        page
      }

      try {
        const res = await getReq('/querySystemLogList', params)
        if (res.errcode === 0) {
          this.$refs.comTable.loading = false

          this.tableData = res.data

          this.pageOption = {
            page: res.page,
            pageSize: res.page_size,
            count: res.count
          }
        } else {
          const err = { tip: res.errmsg }
          throw err
        }
      } catch (error) {
        //统一处理报错提示
      }
    },
    async operateForm(type, record = {}) {
      this.formStatus = type

      if (type == 'edit' || type == 'read') {
        await this.getRuleFormInfo(record)

        this.formModal = true
        this.formState = record
      } else if (type == 'del') {
        this.handleDelete([record.device_id], this.getList)
      } else if (type == 'back') {
        this.formModal = false
        this.getList()
      }
    },
    //  删除操作
    async handleDelete(id, callback) {
      const that = this
      this.$Modal.confirm({
        title: '你确认删除数据吗?',
        icon: createVNode(ExclamationCircleOutlined),

        async onOk() {
          try {
            const res = await getReq('/deleteUser', { user_id: id })
            if (res.errcode === 0) {
              this.$message.success(res.errmsg)
              this.pageOption.page = 1
              callback()
            } else {
              throw res
            }
          } catch (error) {
            callback()
          }
        },
        onCancel() {
          // console.log("Cancel");
        },
        class: 'test'
      })
    },
    async getRuleFormInfo(record) {
      const row = record || {}

      for (let e of syslogOptions) {
        for (let i of e.list) {
          e.ruleForm[i.key] = row[i.key] || ''
        }
      }
    },
    handlePagesizeChange(pageOption) {
      this.pageOption.pageSize = pageOption.pageSize
      this.pageOption.page = pageOption.page
      this.getList()
    }
  }
}
</script>

<style lang="scss" scoped>
.syslog {
  height: 100%;
  padding: 20px;

  .content-table {
    height: 100%;
  }
}
</style>
